local lastcheck, lastvalue = 0, 0
local warn15, warn1, warnlogin = false, false, false
local TBReminder = CreateFrame("frame")
local elapsed = 0
local allianceControlled = false
local WGlastcheck, WGlastvalue = 0, 0
local WGwarn15, WGwarn1, WGwarnlogin = false, false, false

TBReminder:SetScript("OnEvent", function(self, event, ...)
    self[event](self, ...)
end)

local function isAllianceControlled()
	local continent = GetCurrentMapContinent()
    	if IsInInstance() or continent == 3 or continent == 4 or continent == 5 then 
		return
	end
    local areaId = GetCurrentMapAreaID()
    SetMapByID(14) -- Eastern Kingdoms
    for i=1,GetNumMapLandmarks() do
        local name, desc = GetMapLandmarkInfo(i)
        if desc then
            if desc == "Alliance Controlled" then
                allianceControlled = 1
                break
            elseif desc == "Horde Controlled" then
                allianceControlled = 0
                break
            end
        else
            allianceControlled = false

        end
    end
    SetMapToCurrentZone()
end

local function CheckTBStartTime()
	local gt = GetTime()
	if IsInInstance() then 
		if lastcheck == 0 then
			return -1
		end
		if lastcheck+lastvalue >= gt then
			return lastvalue-(gt-lastcheck)
		elseif lastcheck+lastvalue >= gt+(60*4) then
			return 0
		else
			allianceControlled = false
			return -1
		end
	end
	
	local _, _, isActive, canQueue, startTime, _ = GetWorldPVPAreaInfo(2);

	if isActive == nil then
		return -1
	elseif isActive then
		return 0
	elseif startTime == nil then
		return -1
	end

	if not allianceControlled then
		isAllianceControlled()
	end

	lastvalue = startTime
	lastcheck = gt

	return startTime
end


local function CheckWGStartTime()
	local gt = GetTime()
	if IsInInstance() then 
		if WGlastcheck == 0 then
			return -1
		end
		if WGlastcheck+WGlastvalue >= gt then
			return WGlastvalue-(gt-WGlastcheck)
		elseif WGlastcheck+WGlastvalue >= gt+(60*4) then
			return 0
		else
		--	allianceControlled = false
			return -1
		end
	end
	
	local _, _, isActive, canQueue, startTime, _ = GetWorldPVPAreaInfo(1);

	if isActive == nil then
		return -1
	elseif isActive then
		return 0
	elseif startTime == nil then
		return -1
	end

	WGlastvalue = startTime
	WGlastcheck = gt

	return startTime
end


-- This function might not be needed
local function CanQueueToTB()
	if IsInInstance() then 
		return false
	end
	
	local _, _, _, canQueue, _, _ = GetWorldPVPAreaInfo(2);

	if not canQueue then
		return false
	end

	return canQueue
end


local function PrintTimer(fromAuto)
	local st = CheckTBStartTime()
	if st == -1 then
		print ("The Tol Barad start time is currently unknown, this can be because you are inside an instance, battleground, arena or in Outland, Northrend or Pandaria.")
		return
	end

	local seconds, minutes, factionNum
	local faction, _ = UnitFactionGroup("player")
	local mode = ""
	st = floor((st/15)+0.5)*15
	minutes = floor(st/60)
	seconds = st-(minutes*60)

	if faction == "Alliance" then
		factionNum = 1
	else
		factionNum = 0
	end
	
	
	if not allianceControlled then -- meaning unknown
		isAllianceControlled()
	end

	if not allianceControlled then -- = unknown
		mode = ""
	elseif allianceControlled == factionNum then
		if GetLocale() == "enUS" and GetCVar("portal") == "eu" then
			mode = " (Defence)"
		else 
			mode = " (Defense)"
		end
	else
		mode = " (Attack)"
	end


	if st == 0 then
		print ("|cffff0000The Tol Barad battle is currently in progress!"..mode.."|r")
	elseif minutes == 0 then
		if TBReminderDB.disableguild or not fromAuto or not IsInGuild() then
			print ("|cffff0000The Battle for Tol Barad is starting in "..seconds.." seconds!"..mode.."|r")
		else
			SendChatMessage("[TolBaradReminder] The Battle for Tol Barad is starting in "..seconds.." seconds!"..mode.."", "GUILD")
		end
	elseif minutes == 1 and seconds < 10 then
		if TBReminderDB.disableguild or not fromAuto or not IsInGuild() then
			print ("|cffff0000The Battle for Tol Barad is starting in 1 minute!"..mode.."|r")
		else
			SendChatMessage("[TolBaradReminder] The Battle for Tol Barad is starting in 1 minute!"..mode.."", "GUILD")
		end
	elseif minutes < 5 then
		if TBReminderDB.disableguild or not fromAuto or not IsInGuild() then
			print ("|cffff0000The Battle for Tol Barad is starting in "..minutes.." minutes and "..seconds.." seconds!"..mode.."|r")
		else
			SendChatMessage("[TolBaradReminder] The Battle for Tol Barad is starting in "..minutes.." minutes and "..seconds.." seconds!"..mode.."", "GUILD")
		end
	else
		if TBReminderDB.disableguild or not fromAuto or not IsInGuild() then
			print("The Battle for Tol Barad is starting in "..minutes.." minutes."..mode.."")
		else
			SendChatMessage("[TolBaradReminder] The Battle for Tol Barad is starting in "..minutes.." minutes!"..mode.."", "GUILD")
		end
	end
end



local function PrintWGTimer(fromAuto)
	local st = CheckWGStartTime()
	if st == -1 then
		print ("The Wintergrasp start time is currently unknown, this can be because you are inside an instance, battleground, arena.")
		return
	end

	local seconds, minutes
	st = floor((st/15)+0.5)*15
	minutes = floor(st/60)
	seconds = st-(minutes*60)

	if st == 0 then
		print ("|cffff0000The Wintergrasp battle is currently in progress!|r")
	elseif minutes == 0 then
		if TBReminderDB.disableguild or not fromAuto or not IsInGuild() then
			print ("|cffff0000The Wintergrap battle is starting in "..seconds.." seconds!|r")
		else
			SendChatMessage("[TolBaradReminder] The Wintergrasp battle is starting in "..seconds.." seconds!", "GUILD")
		end
	elseif minutes == 1 and seconds < 10 then
		if TBReminderDB.disableguild or not fromAuto or not IsInGuild() then
			print ("|cffff0000The Wintergrasp battle is starting in 1 minute!|r")
		else
			SendChatMessage("[TolBaradReminder] The Wintergrasp battle is starting in 1 minute!", "GUILD")
		end
	elseif minutes < 5 then
		if TBReminderDB.disableguild or not fromAuto or not IsInGuild() then
			print ("|cffff0000The Wintergrasp battle is starting in "..minutes.." minutes and "..seconds.." seconds!|r")
		else
			SendChatMessage("[TolBaradReminder] The Wintergrasp battle is starting in "..minutes.." minutes and "..seconds.." seconds!", "GUILD")
		end
	else
		if TBReminderDB.disableguild or not fromAuto or not IsInGuild() then
			print("The Wintergrasp Battle is starting in "..minutes.." minutes.")
		else
			SendChatMessage("[TolBaradReminder] The Wintergrasp battle is starting in "..minutes.." minutes!", "GUILD")
		end
	end
end


local function RunTBCheck(fromAuto)
	local st = CheckTBStartTime()
	if st > 0 and st <= (15*60) then
		if st > 60 and not warn15 then
			PrintTimer(fromAuto)
			warn15 = true
			warnlogin = true
		elseif st <= 60 and not warn1 then
			PrintTimer(fromAuto)
			warn1 = true
			warnlogin = true
		end
	elseif not warnlogin then
		if not TBReminderDB.disablelogin and not IsInInstance() then
			PrintTimer(false)
		end
		warnlogin = true
	end

	if st == 0 then
		warn1 = false
		warn15 = false
		allianceControlled = false
	end

end

local function RunWGCheck(fromAuto)
	local st = CheckWGStartTime()
	if st > 0 and st <= (15*60) then
		if st > 60 and not WGwarn15 then
			PrintWGTimer(fromAuto)
			WGwarn15 = true
			WGwarnlogin = true
		elseif st <= 60 and not WGwarn1 then
			PrintWGTimer(fromAuto)
			WGwarn1 = true
			WGwarnlogin = true
		end
	elseif not WGwarnlogin then
		if not TBReminderDB.disablelogin and not IsInInstance() then
			PrintWGTimer(false)
		end
		WGwarnlogin = true
	end

	if st == 0 then
		WGwarn1 = false
		WGwarn15 = false
	end

end

function TBReminder:ADDON_LOADED(addon)
    if addon ~= "TolBaradReminder" then return end

    local defaults = {
		disablelogin = false,
		disableaddon = false,
		disableguild = false,
		enableWG = false
	}
		
	TBReminderDB = TBReminderDB or {}
		
	for k,v in pairs(defaults) do
		if TBReminderDB[k] == nil then
			TBReminderDB[k] = v
		end
	end


	SLASH_TBREMINDER1, SLASH_TBREMINDER2, SLASH_TBREMINDER3, SLASH_TBREMINDER4 = "/tbtime", "/tbtimer", "/tbreminder", "/tbr"
	SlashCmdList.TBREMINDER = function(msg)
		msg = msg:lower():gsub(" ", "")
		if msg == "" then
			PrintTimer()
		elseif msg == "wg" then
			PrintWGTimer()
		elseif msg == "guildenable" then
			TBReminderDB.disableguild = false
			print("Guild announcement is now |cff00DD00enabled|r.")
		elseif msg == "guilddisable" then
			TBReminderDB.disableguild = true
			print("Guild announcement is now |cffFF0000disabled|r. Messages will be printed only to you.")
		elseif msg == "loginenable" then
			TBReminderDB.disablelogin = false
			print("Login announcement is now |cff00DD00enabled|r.")
		elseif msg == "logindisable" then
			TBReminderDB.disablelogin = true
			print("Login announcement is now |cffFF0000disabled|r.")




		elseif msg == "wg_enable" then
			TBReminderDB.enableWG = true
			print("Wintergrasp announcements are now |cff00DD00enabled|r.")
		elseif msg == "wg_disable" then
			TBReminderDB.enableWG = true
			print("Wintergrasp announcements are now |cffFF0000disabled|r.")



		elseif msg == "disable" then
			TBReminderDB.disableaddon = true
			TBReminder:SetScript("OnUpdate", nil)
			print("All announcements are now |cffFF0000disabled|r.")
		elseif msg == "enable" then
			TBReminderDB.disableaddon = false
			TBReminder:SetScript("OnUpdate", function(self, e)
				TBReminder:MainLoop(e)
			end)
			print("All announcements are now |cff00DD00enabled|r.")

		else
			print("Tol Barad reminder commands: (/tbr, /tbtime, /tbtimer and /tbreminder all work)")
			print("|cff3399FF/tbr|r displays the time until the next Tol Barad battle (if available).")
			print("|cff3399FF/tbr wg|r displays the time until the next Wintergrasp battle (if available).")
			print("|cff3399FF/tbr disable|r disables all output from the addon except if initiated by typing the /tbtime command.")
			print("|cff3399FF/tbr enable|r enables all output by the addon.")
			print("|cff3399FF/tbr logindisable|r disables the time announcement on login.")
			print("|cff3399FF/tbr loginenable|r enables the time announcement on login.")
			print("|cff3399FF/tbr guilddisable|r sets the announcement to print only to you, and not in guild chat.")
			print("|cff3399FF/tbr guildenable|r sets the announcement to print to guild chat.")
			print("|cff3399FF/tbr wg_enable|r also enables Wintergrasp announcements.")
			print("|cff3399FF/tbr wg_disable|r disables Wintergrasp announcements.")
		end

	end




	if not TBReminderDB.disableaddon then
		TBReminder:SetScript("OnUpdate", function(self, e)
			TBReminder:MainLoop(e)
		end)
	end

end

TBReminder:RegisterEvent("ADDON_LOADED")

function TBReminder:MainLoop(e)
   elapsed = elapsed + e
   if elapsed >= 7 then
       RunTBCheck(true)
	if TBReminderDB.enableWG then
		RunWGCheck(true)
	end
       elapsed = 0
   end
end

